Description

This is a condensed version of the Django tutorial found here

Setup The Environment

e Setup a python virtual environment to develop in
o For Arch Linux use issue #876
o For FreeBSD use issue #874

Install Django

¢ Switch to the pydev user and activate the virtualenv:

su — pydev
source ~/venv/new_app/bin/activate

* And install Django:

pip install Django

New Django App

e Create a new Django project:

django-admin startproject www_example_com
cd www_example_com

e Edit the project settings.py file:

vi www_example_com/settings.py

o And add the host IP address of the local development machine:
ALLOWED_HOSTS = ['192.168.1.90"']
e Test the new app by running the development test web server:

./manage.py runserver 0.0.0.0:8000

NOTE: Press CTRL+C to stop the test web server
* Now create a new simple poll web application:

./manage.py startapp polls

Initial Framework
Create View

e Create the initial view:

vi polls/views.py

o And add the following:

from django.shortcuts import render
from django.http import HttpResponse

def index (request) :

e Now map the view to a URL by creating:

vi polls/urls.py

o And add the following:

from django.conf.urls import url
from . import views
app_name = 'polls'

urlpatterns = [
url(r'”$', views.index, name='index'),

e Next, point the root URLconf at the polls.urls module:

vi www_example_com/urls.py
o And add the URL handler the polls/ part of the web application:
from django.conf.urls import include, url
from django.contrib import admin
app_name = 'polls'
urlpatterns = [

url(r'”polls/"', include('polls.urls')),
url (r'~admin/', admin.site.urls),

® Rerun the development test server:

./manage.py runserver 0.0.0.0:8000
o And open a web browser and go to http://192.168.1.90/polls
NOTE: Press CTRL+C to stop the test web server

Connect to a Database

® Begin by initializing the database:

./manage.py migrate

Create Model

o Create the data model file:

vi polls/models.py

o And add the following to create two data models, Question and Choice:

import datetime
from django.db import models
from django.utils import timezone

class Question (models.Model) :
question_text = models.CharField (max_length=200)
pub_date = models.DateTimeField('date published')

def _ str_ (self):
return self.question_text

def was_published_recently(self):
now = timezone.now ()
return now - datetime.timedelta (days=1l) <= self.pub_date <= now

class Choice (models.Model) :
question = models.ForeignKey (Question, on_delete=models.CASCADE)
choice_text = models.CharField(max_length=200)
votes = models.IntegerField(default=0)

def _ str_ (self):
return self.choice_text

o Edit the www_example_com/settings.py file:

vi www_example_com/settings.py

o And add the polls.apps.PollsConfig dotted path to the INSTALLED_APPS setting to include the app in our project:

INSTALLED_APPS = [
'polls.apps.PollsConfig’,
'django.contrib.admin',
'django.contrib.auth’',
'django.contrib.contenttypes’,
'django.contrib.sessions',
'django.contrib.messages',
'django.contrib.staticfiles"’,

* Now create the polls data model migrations to update the database structure:
./manage.py makemigrations polls

e Then apply the migration:

./manage.py migrate

Adding Questions

e Start the management shell:

./manage.py shell
o And run the following to create a question:
import django
from polls.models import Question, Choice
from django.utils import timezone
g = Question(question_text="What's new?", pub_date=timezone.now())
g.save ()

Adding Choices

e Start the management shell:

./manage.py shell
o And run the following to create two choices:
import django
from polls.models import Question, Choice
from django.utils import timezone
g = Question.objects.get (pk=1)

g.choice_set.create (choice_text="'Not much', votes=0)
g.choice_set.create(choice_text='Same Stuff, Different Day', votes=0)

Admin Interface

e Create an admin user:

./manage.py createsuperuser

o Edit the admin file for the poll app:

vi polls/admin.py
o And add the following to make the poll app modifiable in the admin interface
from django.contrib import admin
from .models import Question

admin.site.register (Question)
® Rerun the development test server:

./manage.py runserver 0.0.0.0:8000

o And open a web browser and go to http://192.168.1.90/admin
NOTE: Press CTRL+C to stop the test web server

Extending a View With Arguments

e Edit the polls/views.py file:

vi polls/views.py

o Add a few more views to polls/views.py. These views are slightly different, because they take an argument:

# Add after the index function
def detail (request, question_id):

)

return HttpResponse ("You're looking at question %s." % question_id)

def results(request, question_id):
response = "You're looking at the results of question %s."

o)

return HttpResponse (response % question_id)

def vote(request, question_id):

)

return HttpResponse ("You're voting on question %s." $ question_id)
® Then edit the polls/urls.py file:

vi polls/urls.py

o And add the new views into the polls.urls module by adding the following url() calls:

from django.conf.urls import url
from . import views

app_name = 'polls'

urlpatterns = [
url(r'”$', views.index, name='index'),
url (r'” (?P<question_id>[0-9]+)/$"', views.detail, name='detail'),

url (r'” (?P<question_id>[0-9]+) /results/$', views.results, name='results'),
(r

url (r'” (?P<question_id>[0-9]+) /vote/$', views.vote, name='vote'),

Dynamic Views

e Edit the views of the polls app:

vi polls/views.py
o And refactor the index() view to display the latest 5 poll questions in the system, separated by commas, according to

publication date:

from django.http import HttpResponse
from django.shortcuts import render
from .models import Question
def index (request) :
latest_question_list = Question.objects.order_by ('-pub_date') [:5]
context = {'latest_question_list': latest_question_list}
return render (request, 'polls/index.html', context)

# Leave the rest of the views (detail, results, vote) unchanged

e Create a directory for templates in the polls app, then another directory in the templates directory for polls:

mkdir polls/templates
mkdir polls/templates/polls

e Then create a template for the index of the polls app:

vi polls/templates/polls/index.html

o And add the following:

{$ if latest_question_list %}
<ul>
{% for question in latest_question_list %}
<li><a href="{% url 'polls:detail' question.id %}">{{ question.question_text }}</a

></1i>
{% endfor %}
</ul>

{% else %}
<p>No polls are available.</p>
{%$ endif %}

404 Error Page

e Edit the polls app views:

vi polls/views.py

o And refactor the detail() view to display a 404 error for non-existent objects:

from django.shortcuts import get_object_or_404, render
from .models import Question

#

def detail (request, question_id):

question = get_object_or_404 (Question, pk=question_id)
return render (request, 'polls/detail.html', {'question': question})

e And create a template for the detail page in the polls app:

vi polls/templates/polls/detail.html

o And add the following:

<hl>{{ question.question_text }}</hl>
<ul>
{% for choice in question.choice_set.all %}
<1i>{{ choice.choice_text }}</1i>
{% endfor %}
</ul>

Create a Form

e Edit the polls app detail template:

vi polls/templates/polls/detail.html

o And refactor the template to add an HTML <form> element:

<hl>{{ question.question_text }}</hl>
{%$ if error_message $%$}<p><strong>{{ error_message }}</strong></p>{% endif %}

<form action="{% url 'polls:vote' question.id %}" method="post">
{% csrf_token %}
{% for choice in question.choice_set.all %}
<input type="radio" name="choice" id="choice{{ forloop.counter }}" value="{{ choice.id
/>
<label for="choice{{ forloop.counter }}">{{ choice.choice_text }}</label><br />
{% endfor %}
<input type="submit" value="Vote" />
</form>

e Edit the polls app views handler:

vi polls/views.py

o And refactor the vote() and results() functions to create the real versions:

from django.shortcuts import get_object_or_404, render
from django.http import HttpResponseRedirect, HttpResponse
from django.urls import reverse

from .models import Choice, Question

#
def results(request, question_id):
question = get_object_or_404 (Question, pk=question_id)
return render (request, 'polls/results.html', {'question': question})

def vote(request, question_id):
question = get_object_or_404 (Question, pk=question_id)
try:
selected_choice = question.choice_set.get (pk=request.POST|['choice'])
except (KeyError, Choice.DoesNotExist):
# Redisplay the question voting form.
return render (request, 'polls/detail.html', {
'question': question,
'error_message': "You didn't select a choice.",
})
else:
selected_choice.votes += 1
selected_choice.save ()
# Always return an HttpResponseRedirect after successfully dealing
# with POST data. This prevents data from being posted twice if a
# user hits the Back button.
return HttpResponseRedirect (reverse('polls:results', args=(question.id,)))
e Create the polls app template for the results:

vi polls/templates/polls/results.html

o And add the following:

<hl>{{ question.question_text }}</hl>

<ul>
{% for choice in question.choice_set.all %}

<li>{{ choice.choice_text }} —— {{ choice.votes }} vote{{ choice.votes|pluralize }}</1

i>
{% endfor %}
</ul>

<a href="{% url 'polls:detail' question.id %}">Vote again?</a>

Refactoring

e Edit the polls app URL handler:

vi polls/urls.py

o And refactor the second and third URL regexes that handle the Detail and Results views:

from django.conf.urls import url
from . import views

app_name = 'polls'
urlpatterns = [
url(r'~$', views.IndexView.as_view(), name='index'),
url (r'” (?P<pk>[0-9]+)/$', views.DetailView.as_view(), name='detail'),
url (r'” (?P<pk>[0-9]+) /results/$', views.ResultsView.as_view(), name='results'),
url (r'” (?P<question_id>[0-9]+) /vote/$', views.vote, name='vote'),

* Then edit the polls app views handler:

vi polls/views.py

e Refactor the old index(), detail(), and results() views and use Django’s generic views instead:

from django.shortcuts import get_object_or_404, render
from django.http import HttpResponseRedirect

from django.urls import reverse

from django.views import generic

from django.utils import timezone

from .models import Choice, Question

class IndexView (generic.ListView) :
template_name = 'polls/index.html'
context_object_name = 'latest_question_list'

def get_queryset (self):

nun

Return the last five published questions (not including those set to be
published in the future).

04/10/2024 8/11




mmwn
return Question.objects.filter(
pub_date__ lte=timezone.now ()
) .order_by ('-pub_date') [:5]
class DetailView (generic.DetailView) :
model = Question

template_name = 'polls/detail.html'
def get_qgueryset (self):

nun

Excludes any questions that aren't published yet.
nmn

return Question.objects.filter (pub_date__lte=timezone.now())

class ResultsView(generic.DetailView) :
model = Question
template_name = 'polls/results.html'

Static Files
CSS

e Create a CSS file for the polls app:

vi polls/static/polls/style.css

o And add the following:

1i a {
color: green;

¢ Next, edit the polls app index.html template:

vi polls/templates/polls/index.html

o An add the following at the top:

{% load static %}

<link rel="stylesheet" type="text/css" href="{% static 'polls/style.css' %}" />

Background Image

e Create an images subdirectory in the polls/static/polls/ directory:

mkdir polls/static/polls/image
NOTE: Inside this directory, put an image called background.gif.

e Then, edit the stylesheet created earlier:

vi polls/static/polls/style.css

o And add the following:
body {
background: white url ("image/background.gif") no-repeat right bottom;

e Set the STATIC_ROOT setting to the directory from which you'd like to serve these files:

STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, 'static')

* Run the collectstatic management command:

./manage.py collectstatic

Resources

e https://docs.djangoproject.com/en/1.10/intro/tutorial01/

History

#1 - 12/03/2016 02:52 PM - Daniel Curtis
- Description updated
- Status changed from New to In Progress

- % Done changed from 0 to 20

#2 - 12/03/2016 04:26 PM - Daniel Curtis
- Description updated

#3 - 12/03/2016 05:06 PM - Daniel Curtis

- Description updated

- Start date changed from 12/03/2016 to 12/04/2016
- % Done changed from 20 to 40

#4 - 12/03/2016 09:29 PM - Daniel Curtis

- Description updated

#5 - 12/04/2016 03:40 PM - Daniel Curtis
- Description updated

- % Done changed from 40 to 50

#6 - 12/04/2016 04:37 PM - Daniel Curtis
- Description updated

#7 - 12/04/2016 08:16 PM - Daniel Curtis
- Description updated
- % Done changed from 50 to 60

#8 - 12/04/2016 09:16 PM - Daniel Curtis
- Description updated

- % Done changed from 60 to 100

#9 - 12/04/2016 09:38 PM - Daniel Curtis
- Description updated

- Status changed from In Progress to Resolved
#10 - 12/04/2016 09:58 PM - Daniel Curtis
- Description updated

#11 - 12/07/2016 06:36 PM - Daniel Curtis
- Description updated

#12 - 12/07/2016 07:04 PM - Daniel Curtis
- Description updated

#13 - 06/04/2017 08:54 PM - Daniel Curtis

- Status changed from Resolved to Closed
